// Code generated by sqlc. DO NOT EDIT.
// versions:
//   sqlc v1.25.0
// source: patients.sql

package db

import (
	"context"
	"database/sql"
	"time"
)

const createPatient = `-- name: CreatePatient :one
INSERT INTO patients (
    code,
    name,
    gender,
    birthday,
    email,
    phone,
    country_code
) VALUES (
    $1, $2, $3, $4, $5, $6, $7
) RETURNING id, code, name, gender, birthday, email, phone, country_code
`

type CreatePatientParams struct {
	Code        string         `json:"code"`
	Name        string         `json:"name"`
	Gender      sql.NullString `json:"gender"`
	Birthday    time.Time      `json:"birthday"`
	Email       sql.NullString `json:"email"`
	Phone       string         `json:"phone"`
	CountryCode int32          `json:"country_code"`
}

func (q *Queries) CreatePatient(ctx context.Context, arg CreatePatientParams) (Patients, error) {
	row := q.db.QueryRowContext(ctx, createPatient,
		arg.Code,
		arg.Name,
		arg.Gender,
		arg.Birthday,
		arg.Email,
		arg.Phone,
		arg.CountryCode,
	)
	var i Patients
	err := row.Scan(
		&i.ID,
		&i.Code,
		&i.Name,
		&i.Gender,
		&i.Birthday,
		&i.Email,
		&i.Phone,
		&i.CountryCode,
	)
	return i, err
}

const deletePatient = `-- name: DeletePatient :exec
DELETE FROM patients WHERE id = $1
`

func (q *Queries) DeletePatient(ctx context.Context, id int64) error {
	_, err := q.db.ExecContext(ctx, deletePatient, id)
	return err
}

const getPatient = `-- name: GetPatient :one
SELECT id, code, name, gender, birthday, email, phone, country_code FROM patients
WHERE id = $1 LIMIT 1
`

func (q *Queries) GetPatient(ctx context.Context, id int64) (Patients, error) {
	row := q.db.QueryRowContext(ctx, getPatient, id)
	var i Patients
	err := row.Scan(
		&i.ID,
		&i.Code,
		&i.Name,
		&i.Gender,
		&i.Birthday,
		&i.Email,
		&i.Phone,
		&i.CountryCode,
	)
	return i, err
}

const listPatients = `-- name: ListPatients :many
SELECT id, code, name, gender, birthday, email, phone, country_code FROM patients
ORDER BY id
LIMIT $1
OFFSET $2
`

type ListPatientsParams struct {
	Limit  int64 `json:"limit"`
	Offset int64 `json:"offset"`
}

func (q *Queries) ListPatients(ctx context.Context, arg ListPatientsParams) ([]Patients, error) {
	rows, err := q.db.QueryContext(ctx, listPatients, arg.Limit, arg.Offset)
	if err != nil {
		return nil, err
	}
	defer rows.Close()
	var items []Patients
	for rows.Next() {
		var i Patients
		if err := rows.Scan(
			&i.ID,
			&i.Code,
			&i.Name,
			&i.Gender,
			&i.Birthday,
			&i.Email,
			&i.Phone,
			&i.CountryCode,
		); err != nil {
			return nil, err
		}
		items = append(items, i)
	}
	if err := rows.Close(); err != nil {
		return nil, err
	}
	if err := rows.Err(); err != nil {
		return nil, err
	}
	return items, nil
}

const updatePatient = `-- name: UpdatePatient :exec
UPDATE patients 
SET name = $2
WHERE id = $1
`

type UpdatePatientParams struct {
	ID   int64  `json:"id"`
	Name string `json:"name"`
}

func (q *Queries) UpdatePatient(ctx context.Context, arg UpdatePatientParams) error {
	_, err := q.db.ExecContext(ctx, updatePatient, arg.ID, arg.Name)
	return err
}
